//Fernando Iannacci
//DataConnection.java
//Separate class implementing things related with the database

import java.sql.*;
import javax.swing.*;
import java.util.Vector;
public class DataConnection
{

	public Connection dbconn;
	public JScrollPane sp;
	public DataConnection(String dbPath,String user, String pw) {
		 try {
		 	String url = "jdbc:odbc:" + dbPath;
		  	Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
		    dbconn = DriverManager.getConnection(url,user,pw);
		 }
		 catch (ClassNotFoundException connFound) {
		 	connFound.printStackTrace();
		    System.exit(-1);
		 }
		 catch (Exception excp) {
		 	excp.printStackTrace();
		    System.exit(-1);
      	 }
	}


	public boolean search(String sql, JFrame main) {
		try {
			Statement statement = dbconn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
			ResultSet result = statement.executeQuery(sql);
			if(! result.next()) {
				statement.close();
				return false;
			}
			statement.close();
		}
		catch(SQLException sqle){
			JOptionPane.showMessageDialog(main, "Cannot run SQL" + sqle, "ERROR", JOptionPane.WARNING_MESSAGE);
		}
		return true;
	}



	public void executeSql(String sql, JFrame main, String operation) {
		try {
			Statement sta = dbconn.createStatement();
			int rows = sta.executeUpdate(sql);
			if(rows==0){
				JOptionPane.showMessageDialog(main, "Record not " + operation);
			}
			else{
				JOptionPane.showMessageDialog(main, "Record " + operation);
			}
				sta.close();
			}
			catch(SQLException sqle){
				JOptionPane.showMessageDialog(main, "Cannot run SQL" + sqle, "ERROR", JOptionPane.WARNING_MESSAGE);
			}

	}


	public boolean dataTable(String sql, JFrame main) {
		try {
			Vector columns = new Vector();
			Vector rows = new Vector();
			Statement statement = dbconn.createStatement();
			ResultSet res = statement.executeQuery(sql);
			DatabaseMetaData md = dbconn.getMetaData();
			ResultSetMetaData resMD = res.getMetaData();
			Vector currentRow = null;
			if(! res.next()){
				JOptionPane.showMessageDialog(main, "SEARCH: No record were found in database","Search Results",  JOptionPane.WARNING_MESSAGE);
				statement.close();
				return false;
			}
			else {
				for(int x=1; x <= resMD.getColumnCount(); x++) {
					columns.addElement(resMD.getColumnName(x));
				}
				do {
					currentRow = new Vector();
					for (int x = 0; x < columns.size(); x++) {
						currentRow.addElement(res.getString(x+1));
					}
					rows.addElement(currentRow);
				} while (res.next());

				JTable table = new JTable(rows, columns);
				sp = new JScrollPane(table);

			}
			statement.close();
		}
		catch(SQLException sqle){
			JOptionPane.showMessageDialog(main, "Cannot run SQL" + sqle, "ERROR", JOptionPane.WARNING_MESSAGE);
		}
		return true;
	}

}