//Assignment N.5
//by Fernando Iannacci
//PhoneBook.java

import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

class SetButton extends JButton
{
	public SetButton(String butName )
  	{
    	setText(butName);
    	setContentAreaFilled(false);
    	setFocusPainted(false);
    	setBorderPainted(false);
    	setForeground (new Color(0, 0, 150));
  		setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		setFont(new Font("Arial", Font.BOLD, 14));
    	setFocusPainted(false);
  	}
}
//---------------------------------------------------------------------------------
class PhoneFrame extends JDialog implements ActionListener
{
	private JTextField name;
	private JTextField phone;
	private JTextArea address;
	private JTextField city;
	private JTextField pcode;
	private JTextField prov;
	private JFrame main;
	private boolean flag;
	private String storePhone;
	DataConnection connection;

	public PhoneFrame(JFrame mainWindow, String title, boolean mod, boolean windFlag, DataConnection sun)
	{
		super(mainWindow, title, mod);
		flag = windFlag;
		main = mainWindow;
		connection = sun;
		int row = 1;
		GridBagLayout custLayout = new GridBagLayout();
		getContentPane().setLayout(custLayout);


		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension screenDim = tk.getScreenSize();

		GridBagConstraints phoneConstraints = new GridBagConstraints();

	    String nlabel;
	    if (title.equals("Find Entry"))
	    	nlabel = "Enter Name:";
	    else
	    	nlabel = "Name:";

	    JLabel nameLabel = new JLabel(nlabel);
	 	setConstraints(phoneConstraints, 0, 0, 1, 1);
		phoneConstraints.weightx = 0;
		phoneConstraints.weighty = 0;
		phoneConstraints.anchor = GridBagConstraints.EAST;
		phoneConstraints.insets.top = 5;
		phoneConstraints.insets.right = 0;
		phoneConstraints.insets.left = 0;
		getContentPane().add(nameLabel, phoneConstraints);

		if(!(title.equals("Delete Entry") || title.equals("Find Entry") || (title.equals("Update Entry") && !windFlag)))
		{
			row = 7;
			phoneConstraints.insets.top = 10;
			JLabel addressLabel = new JLabel("Address:");
			setConstraints(phoneConstraints, 0, 1, 1, 1);
			getContentPane().add(addressLabel, phoneConstraints);

			JLabel cityLabel = new JLabel("City:");
			setConstraints(phoneConstraints, 0, 4, 1, 1);
			getContentPane().add(cityLabel, phoneConstraints);

			JLabel provinceLabel = new JLabel("Province:");
			setConstraints(phoneConstraints, 0, 5, 1, 1);
			getContentPane().add(provinceLabel, phoneConstraints);

			JLabel pcodeLabel = new JLabel("Postal Code:");
			setConstraints(phoneConstraints, 0, 6, 1, 1);
			getContentPane().add(pcodeLabel, phoneConstraints);

			phoneConstraints.insets.left = 10;
			phoneConstraints.insets.top = 10;
			address = new JTextArea(3,20);
			JScrollPane js = new JScrollPane(address);
			address.setLineWrap(true);
			address.setWrapStyleWord(true);
			setConstraints(phoneConstraints, 1, 1, 1, 3);
			getContentPane().add(js, phoneConstraints);

			city = new JTextField("", 20);
			setConstraints(phoneConstraints, 1, 4, 1, 1);
			getContentPane().add(city, phoneConstraints);

			prov = new JTextField("", 20);
			setConstraints(phoneConstraints, 1, 5, 1, 1);
			getContentPane().add(prov, phoneConstraints);

			pcode = new JTextField("", 20);
			setConstraints(phoneConstraints, 1, 6, 1, 1);
			getContentPane().add(pcode, phoneConstraints);

		}

		phoneConstraints.insets.left = 10;
		phoneConstraints.insets.top = 5;
		name = new JTextField("", 20);
		setConstraints(phoneConstraints, 1, 0, 1, 1);
		getContentPane().add(name, phoneConstraints);

		if(!(title.equals("Find Entry")))
		{
			JLabel PhoneLabel = new JLabel("Phone:");
			setConstraints(phoneConstraints, 0, row, 1, 1);
			getContentPane().add(PhoneLabel, phoneConstraints);

			phone = new JTextField("", 20);
			setConstraints(phoneConstraints, 1, row, 1, 1);
			getContentPane().add(phone, phoneConstraints);
		}


		phoneConstraints.insets.left = 0;
		phoneConstraints.insets.top = 25;

        JButton addButton = new JButton(title);
		addButton.addActionListener(this);

		JButton cancelButton = new JButton("Cancel");
	    cancelButton.addActionListener(this);

	    Box b = Box.createHorizontalBox();
		b.add(addButton);
		b.add(cancelButton);


		phoneConstraints.anchor = GridBagConstraints.WEST;
	    setConstraints(phoneConstraints, 1, row + 1, 1, 1);
		getContentPane().add(b, phoneConstraints);

		setFrameSize(this, 30, 90, 3);

		addWindowListener(new WindowAdapter() {
	 	   	public void windowClosing(WindowEvent e) {
	        System.exit(0);
			}
   	 	});
	}

	public PhoneFrame(JFrame mainWindow, String title, boolean mod, boolean f, String nStr, String pStr, DataConnection sun)
	{
		this(mainWindow, title, mod, f, sun);
		name.setText(nStr);
		phone.setText(pStr);
		name.setEnabled(false);
		storePhone =  pStr;
	}

	public void actionPerformed(ActionEvent ev)
	{
		String source = ev.getActionCommand();
		if(source.equals("Update Entry") && !flag)
  	 	{
			String sql = "SELECT * FROM phone WHERE name =" + "'" + name.getText() + "' and phone =" + "'" +  phone.getText() + "'";

			  if (connection.search(sql, main))
			  {
				  String nameField = name.getText();
				  String phoneField = phone.getText();
				  PhoneFrame updateFrame = new PhoneFrame(main,"Update Entry", true, true, nameField, phoneField, connection);
				  updateFrame.show();
			  }
			  else
				JOptionPane.showMessageDialog(main, "RECORD CANNOT BE UPDATED: It does not exist","UPDATING",  JOptionPane.WARNING_MESSAGE);
	     }

		else if (source.equals("Add Entry"))
		{
			if (!name.getText().equals( "" ) && !address.getText().equals( "" ) && !city.getText().equals( "" ) && !prov.getText().equals( "" ) && !pcode.getText().equals( "" ) && !phone.getText().equals( "" ))
			{
				String sql = "SELECT * FROM phone WHERE name =" + "'" + name.getText() + "' and phone =" + "'" +  phone.getText() + "'";
				if (! connection.search(sql, main)) {
					String values = "'" + name.getText() + "','" + address.getText() + "','" + city.getText() + "','" + prov.getText() + "','" + pcode.getText() + "','" + phone.getText() + "'";
					sql = "INSERT INTO phone(name, address, city, province, pcode, phone) VALUES(" + values + ")";
					connection.executeSql(sql, main, "added");
					clearFields();
				}
				else
					JOptionPane.showMessageDialog(main, "RECORD CANNOT BE ADDED: Name and phone number already present in the database","ADDING",  JOptionPane.WARNING_MESSAGE);

			}
			else
				JOptionPane.showMessageDialog(main, "You must enter all the fields", "INVALID DATA", JOptionPane.WARNING_MESSAGE);

		}

		else if (source.equals("Update Entry"))
		{
			if (!address.getText().equals( "" ) && !city.getText().equals( "" ) && !prov.getText().equals( "" ) && !pcode.getText().equals( "" ) && !phone.getText().equals( "" ))
			{
				String sql = "SELECT * FROM phone WHERE name =" + "'" + name.getText() + "' and phone =" + "'" +  phone.getText() + "'";
				if (! connection.search(sql, main) || storePhone.equals(phone.getText())) {
					sql = "UPDATE phone SET address='" + address.getText() + "', city='" + city.getText() + "', province='" + prov.getText() + "', pcode='" + pcode.getText() + "',phone='" + phone.getText() + "' WHERE name ='" + name.getText() + "' and phone ='" + storePhone + "'";
					connection.executeSql(sql, main, "updated");
					dispose();
				}
				else
					JOptionPane.showMessageDialog(main, "RECORD CANNOT BE UPDATED: Name and phone number already present in the database","UPDATING",  JOptionPane.WARNING_MESSAGE);

			}
			else
				JOptionPane.showMessageDialog(main, "You must enter all the fields", "INVALID DATA", JOptionPane.WARNING_MESSAGE);
		}


		else if (source.equals("Delete Entry"))
		{
			if (!name.getText().equals( "" ) && !phone.getText().equals( "" ))
			{
				String sql = "SELECT * FROM phone WHERE name =" + "'" + name.getText() + "' and phone =" + "'" +  phone.getText() + "'";
				if (connection.search(sql, main)) {
					sql = "DELETE FROM phone WHERE name ='" + name.getText() + "' and phone ='" + phone.getText() + "'";
					connection.executeSql(sql, main, "deleted");
					name.setText( "" );
					phone.setText( "" );
				}
				else
					JOptionPane.showMessageDialog(main, "RECORD CANNOT BE DELETED: It does not exist","DELETING",  JOptionPane.WARNING_MESSAGE);

			}
		}


		else if (source.equals("Find Entry")) {
			String sql = "SELECT * FROM phone WHERE name ='" + name.getText() + "'";
			if (connection.dataTable(sql, main)) {
				JDialog doTable = new JDialog(main,"Search Results",true);
				doTable.getContentPane().add(connection.sp);
				setFrameSize(doTable, 30, 230, 2);
				doTable.show();
				name.setText( "" );
			}
		}

	 	else if (source.equals("Cancel"))
	 	{
			dispose();
	 	}
	}


	public void clearFields(){
		name.setText( "" );
		address.setText( "" );
		city.setText( "" );
		prov.setText( "" );
		pcode.setText( "" );
		phone.setText( "" );
	}

	public void setFrameSize(JDialog frame, int hSpacing, int wSpacing, int pos) {
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension screenDim = tk.getScreenSize();
		frame.pack();
		Dimension frameDim = getSize();
		frame.setSize(frameDim.width + wSpacing, frameDim.height + hSpacing);
		frame.setLocation((screenDim.width -frameDim.width - wSpacing)/pos,(screenDim.height - frameDim.height - hSpacing)/pos);
	}



	public void setConstraints(GridBagConstraints Constraints, int x, int y, int w, int h)
	{
		Constraints.gridx = x;
		Constraints.gridy = y;
		Constraints.gridwidth = w;
		Constraints.gridheight = h;
	}
}

//----------------------------------------------------------------------------------------------------



class MainFrame extends JFrame implements ActionListener
{
	private JButton addJButton;
  	private JButton updateJButton;
  	private JButton deleteJButton;
  	private JButton searchJButton;

  	private DataConnection connection;

	public MainFrame(String t, String i, DataConnection cn)
  	{
  		connection = cn;
  		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension screenDim = tk.getScreenSize();
		setTitle(t);

		ImageIcon icon = new ImageIcon(i);
		setIconImage(icon.getImage());

		//instanciate buttons
		addJButton = new SetButton("   Add Entry    ");
	 	//register mouselistener class to make button visible
	 	addJButton.addActionListener(this);
     	addJButton.addMouseListener(new MyMouseListener());

	 	SetButton updateJButton = new SetButton("  Update Entry  ");
	 	updateJButton.addMouseListener(new MyMouseListener());
     	updateJButton.addActionListener(this);

	 	SetButton deleteJButton = new SetButton("  Delete Entry  ");
	 	deleteJButton.addMouseListener(new MyMouseListener());
	 	deleteJButton.addActionListener(this);

	 	SetButton searchJButton = new SetButton("  Search        ");
	 	searchJButton.addMouseListener(new MyMouseListener());
	 	searchJButton.addActionListener(this);

	 	SetButton exitJButton = new SetButton("  Exit            ");
	 	exitJButton.addMouseListener(new MyMouseListener());
	 	exitJButton.addActionListener(this);

		JLabel topLabel = new JLabel("Main Menu");
    	topLabel.setFont(new Font("Arial", Font.ITALIC, 30));

		Box b = Box.createVerticalBox();
		b.add(topLabel);

    	b.add(addJButton);
		b.add(updateJButton);
		b.add(deleteJButton);
		b.add(searchJButton);
		b.add(exitJButton);

		getContentPane().setLayout(new FlowLayout(FlowLayout.CENTER));
		getContentPane().add(b);

		pack();
		Dimension frameDim = getSize();
		int hspacing = 30;
		int wspacing = 230;
		setSize(frameDim.width + wspacing, frameDim.height + hspacing);
		setLocation((screenDim.width -frameDim.width - wspacing)/2,(screenDim.height - frameDim.height - hspacing)/2);
		setDefaultCloseOperation(EXIT_ON_CLOSE);

	}

	public void actionPerformed(ActionEvent e)
	{
  		String source = e.getActionCommand();
  	 	if(source.equals("   Add Entry    "))
  	 	{
	   		PhoneFrame addFrame = new PhoneFrame(this,"Add Entry", true, true, connection);
        	addFrame.show();
   	 	}

  	 	else if(source.equals("  Update Entry  "))
  	 	{
	  		PhoneFrame updateFrame = new PhoneFrame(this,"Update Entry", true, false, connection);
	  		updateFrame.show();
  	 	}
 	 	else if(source.equals("  Delete Entry  "))
	 	{
	  		PhoneFrame deleteFrame = new PhoneFrame(this,"Delete Entry", true, true, connection);
	  		deleteFrame.show();
  	 	}
  	 	else if(source.equals("  Search        "))
	 	{
	   		PhoneFrame searchFrame = new PhoneFrame(this,"Find Entry", true, true, connection);
	   		searchFrame.show();
  	 	}

 	 	else if(source.equals("  Exit            "))
			try {
				connection.dbconn.close();
				System.exit(0);
			}
			catch ( Exception excp ) {
				excp.printStackTrace();
				JOptionPane.showMessageDialog(this, excp.toString());
				System.exit(-1);
			}

 }

//-----------------------------------------------------------------------------------
  //Inner mouse listener class to show and hide buttons
	class MyMouseListener extends MouseAdapter
  	{

    	public void mouseEntered(MouseEvent e)
    	{
			((JButton)e.getSource()).setBorderPainted(true);
    	}
    	public void mouseExited(MouseEvent e){
			((JButton)e.getSource()).setBorderPainted(false);
    	}
  	}
}


//--------------------------------------------------------------------------------

class PhoneBook extends JFrame {
 	public static void main(String args[]) {
		DataConnection theConnection = new DataConnection("phoneDSN", "Ciao","Spaghetti");
		MainFrame mainMenu = new MainFrame("Phone Book", "phone.gif", theConnection);
		mainMenu.show();

	}
}




